import {
    Platform,
    Dimensions,    
  } from 'react-native';

export const _SCREEN = {
    height: Dimensions.get('window').height,
    width: Dimensions.get('window').width,
    ratio: Dimensions.get('window').height / Dimensions.get('window').width
}

export const _APP_SETTINGS = {
    app_market_id: "",
    app_market_id_google:"com.core.coreapp",
    share_app_url: "", 
    share_app_image: "",
    share_app_langding_url:"",
    gcm_sender_id: "",   
    available_languages: [
        {code:"en" ,name: "English"},
        {code:"tr" ,name: "Türkçe"}, 
        {code:"ar",name: "عربى"},
        {code:"bn",name:"বাঙালি"},// bengalce
        {code:"bg",name:"български"},//bulgarca
        {code:"de",name:"Deutsche"}, // 
        {code:"el",name:"Ελληνικά"},
        {code:"es",name:"Español"},
        {code:"fr",name:"Français"},
        {code:"hi",name:"हिंदी"},// hindi
        {code:"id",name:"Indonesia"},
        {code:"it",name:"Italiano"},
        {code:"ja",name:"日本語"},
        {code:"ka",name:"ქართული"},// gürcü
        {code:"pt",name:"Português"},
        {code:"ru",name:"русский"},
        {code:"sv",name:"Svenska"},
        {code:"uk",name:"український"}
    ],//["ar","bn","bg","de","el","en","es","fr","hi","id","it","ja","ka","pt","ru","sv","uk","tr"],
    in_app_purchases:[               
        {   
            group:'premium',
            name:'premium_d90',
            product_id:'',
            duration: '90',
            price: '31.99',
            currency:'$',
            type:'sub',
        },     
    ],      
    colors: {
        Primary:'#81a9bc',
        PrimaryDark: '#688897',
        PrimaryLight: '#9CBDCB',
        Secondary: '#FFFFFF',
        SecondaryDark: '#FFFFFF',
    },
    device_type: Platform.OS === 'ios' ? 2 : 1, // 1= android, 2= ios
    log_mode: 1, // 1 açık, 2 alert, 0 kapalı
    app_id:101,
    version: "5",
};

export const _SERVER_SETTINGS = {
    mode: 'product',//development product
	std_auth_key: '',
	api_url: '', // /apiurl 
	server_domain: "",
	server_url: "",
	develop_api_url: '',
    image_cdn_url: '',
    file_cdn_url: '',
    terms_of_use_url:'',
    privacy_policy_url:'',
};
 