import firebase, { RNFirebase } from 'react-native-firebase';
import { user, store, ez, lang, _APP_SETTINGS, ram } from './' ;

export const fcm = {  

  notificationListener: null,

  dataMessageListener: null,

  init: () => {
    return new Promise((resolve, reject) => {
      firebase.messaging().hasPermission()
      .then(hasPermission => {
        if(!hasPermission) {
          firebase.messaging().requestPermission()
        }

        firebase.messaging().getToken()
        .then(token => {
          if(token) {
            console.log("FCM TOKEN", token);
            store.setItem("_DEVICE_ID", token);
            user.update({ device_id: token });
          }

          fcm.subscribeToTopic("device_type_" + _APP_SETTINGS.device_type);
          fcm.subscribeToTopic("all");
          if(ram.get("_LANGUAGE_CODE")) {
            fcm.subscribeToTopic("language_code_" + ram.get("_LANGUAGE_CODE"));
          }
          if(ram.get("_COUNTRY_CODE")) {
            fcm.subscribeToTopic("country_code_" + ram.get("_COUNTRY_CODE"));
          }
          
          firebase.messaging().onTokenRefresh(token => {
            if(token) {
              console.log("FCM TOKEN REFRESH", token);
              store.setItem("_DEVICE_ID", token);
              user.update({ device_id: token });
            }
          })

          fcm.notificationListener = firebase.notifications().onNotification(notification => {
            console.warn("NOTIFICATION GELDİ KARDEŞ", notification);
          });

          fcm.dataMessageListener = firebase.messaging().onMessage(message => {
            console.warn("DATA MESSAGE GELDİ KARDEŞ", message);
          })


        })

      })
    });    
  },

  subscribeToTopic: (topic) => {
    firebase.messaging().subscribeToTopic('/topics/'+topic)
  },

  unSubscribeFromTopic: (topic) => {
    firebase.messaging().unsubscribeFromTopic('/topics/'+topic)    
  }

}