import DeviceInfo from 'react-native-device-info';
import SInfo from 'react-native-sensitive-info';
import { user } from './user'
import { fcm } from './fcm'
import { iapIOS, iapAndroid } from './iap'
import { _APP_SETTINGS, _SERVER_SETTINGS, store } from './';

export const initialization = {

  prepareAppInfo: () => {
    return new Promise((resolve, reject) => {
      let country_code = DeviceInfo.getDeviceCountry();
      let language_code = DeviceInfo.getDeviceLocale().split('-')[0].toLowerCase();

      store.getItem("_COUNTRY_CODE")
      .then(cc => {
        if (cc) {
          country_code = cc;
        }
        store.setItem("_COUNTRY_CODE", country_code)
        .then(() => {
          store.getItem("_LANGUAGE_CODE")
          .then(lc => {
            if (lc) {
              language_code = lc;
            }
            store.setItem("_LANGUAGE_CODE", language_code)
            .then(() => {
                let unique_device_hash = DeviceInfo.getUniqueID();
                //
                SInfo.getItem('_UNIQUE_DEVICE_HASH',{})
                .then(value => {
                    //console.log(value) //value1
                    if(value)
                    {
                      unique_device_hash = value;
                      store.setItem("_UNIQUE_DEVICE_HASH",unique_device_hash);
                      this.setState({
                        is_device_infos_ok: true
                      });
                    }
                    else
                    {
                      SInfo.setItem("_UNIQUE_DEVICE_HASH",unique_device_hash, {})
                      .then(()=>{
                        console.log("keychain saved") 
                        store.setItem("_UNIQUE_DEVICE_HASH",unique_device_hash);
                        resolve();
                        
                      })
                      .catch(()=>{
                        store.setItem("_UNIQUE_DEVICE_HASH",unique_device_hash);
                        reject();
                        
                      });
                    }
                    
                })
                .catch(()=>{
                  SInfo.setItem("_UNIQUE_DEVICE_HASH",unique_device_hash, {})
                  .then(()=>{
                    //console.log("keychain saved") 
                    store.setItem("_UNIQUE_DEVICE_HASH",unique_device_hash);
                    resolve();
                    
                  })
                  .catch(()=>{
                    ls.setItem("_UNIQUE_DEVICE_HASH",unique_device_hash);
                    reject();
                  });
                }); 
                //
                /*store.setItem("_UNIQUE_DEVICE_HASH", unique_device_hash)
                .then(() => resolve())
                .catch(() => reject())*/
            })            
          })
          .catch(err => reject());
        })        
      })
      .catch(err => reject());
    });
  },

  registerUser: user.register,

  fcmInit: fcm.init,

  iapInit: _APP_SETTINGS.device_type === 1 ? iapAndroid.init : iapIOS.init,
  
}