import { http, store, _APP_SETTINGS, ram} from './';

export const user = {

  register: () => {
    return new Promise((resolve, reject) => {
      store.getItem("_LAST_REVIEW_ASK")
      .then(last_review => {
        if(!last_review) {
          store.setItem("_LAST_REVIEW_ASK", (Math.floor(new Date().getTime()/1000) + 86400));
        }
      })
      .catch(err => {
        console.error("what kinda error is this?")
      });
      
      http.get("app.user.register_v2", {}, false)
      .then(res => {
        if(res.error === 0) {
          store.setItem("_USER", res.data)
          .then(() => {
            resolve(res.data);
          })
          .catch(() => {
            resolve(res.data);
          })
        }
        else {
          reject(res);
        }
      })
      .catch(err => {
        reject(err)
      })      
    })
  },
  
  update: (params, updateLocal?:boolean = true) => {
    if(typeof updateLocal === "undefined") {
      updateLocal = true;
    }    
    return new Promise((resolve, reject) => {
      http.get("app.user.update", params, true)
      .then(res => {
        user.register()
          .finally(() => {
            resolve(res);                       
          });
      })
      .catch(err => {    
            
        reject(err);;
      })
      .finally(() => {        
        if(updateLocal) {
          user.localUpdate(params);
        } 
      });
    });
  },

  localUpdate: (params) => {
    return new Promise((resolve, reject) => {
      let user = ram.get("_USER");

      if(user){
        for(let k in params) {
          user.user[k] = params[k]
        }
        store.setItem("_USER", user)
        .then(() => {
          resolve();
        })
        .catch(() => {
          resolve();
        })
      }
      else {
        reject();
      }
    });
  },

  getUser: () => {
    let user = ram.get("_USER");
    return user ? user.user : false;
  },

  checkVersion: () => {
    return new Promise((resolve, reject) => {
      http.get("app.common.check_version", {version: _APP_SETTINGS.version}, true)
      .then(res => {
        resolve(res);
      })
      .catch(err => {
        reject(err);
      })
    });
  },

  purchaseVerifyIOS: (receipt, transactionId?:string) => {
    return new Promise((resolve,reject)=>{
      http.post("app.purchase.verify_ios",{product: {transactionId:transactionId, receipt:receipt}}, true)
      .then(res=>{
          // user bilgilerini yenilemek içün
          user.register()
          .then(ok=>{
              resolve(res);
          })
          .catch(notok=>{
              resolve(res);
          }) 

      })
      .catch(err=>{
         // user bilgilerini yenilemek içün
          user.register()
          .then(ok=>{
              resolve(err);
          })
          .catch(notok=>{
              resolve(err);
          }) 
      });
    });
  },

}